module Spree
  module Admin
    class AttachmentsController < ResourceController
      protect_from_forgery

      before_action :load_data

      create.before :set_viewable
      update.before :set_viewable

      private

      def load_data
        @product = Spree::Product.friendly.find(params[:product_id])
      end

      def location_after_destroy
        admin_product_attachments_url(@product)
      end

      def location_after_save
        admin_product_attachments_url(@product)
      end

      def set_viewable
        @attachment.viewable_type = 'Spree::Variant'
        @attachment.viewable_id = params[:attachment][:viewable_id]
      end
    end
  end
end
