module Spree
  module Api
    class AttachmentsController < Spree::Api::BaseController
      protect_from_forgery

      def update
        @attachment = Spree::Attachment.accessible_by(current_ability, :update).find(params[:id])
        @attachment.update(attachment_params)
        respond_with(@attachment, default_template: :show)
      end

      private

      def attachment_params
        params.require(:attachment).permit(Spree::Attachment::PERMITTED_ATTACHMENT_ATTRIBUTES)
      end
    end
  end
end
