module Spree
  module ProductDecorator
    def self.included(base)
      base.class_eval do
        delegate :attachments, to: :find_or_build_master
        has_many :variant_attachments, -> { order(:position) }, source: :attachments,
                 through: :variants_including_master
      end
    end
  end
end

Spree::Product.include Spree::ProductDecorator
